#!/usr/bin/env bash
# Copyright 2021 Naver Corporation
# Run this script from within this directory to download the test, validation and train sets:
# ./download.py

LANGS=(ar bg cs da de el en es et fi fr hr hu it ko lt lv nb nl pl pt ro ru sk sv zh)

for src in ${LANGS[@]}; do
    for tgt in ${LANGS[@]}; do
        if [ ${src} = ${tgt} ] || [[ ${src} > ${tgt} ]]; then
            continue
        fi
        pair=${src}-${tgt}
        src_opus=$( echo ${src} | sed 's/zh/zh_cn/' )
        tgt_opus=$( echo ${tgt} | sed 's/zh/zh_cn/' )
        pair_opus=${src_opus}-${tgt_opus}
        url="https://opus.nlpl.eu/download.php?f=TED2020/v1/moses/${pair_opus}.txt.zip"
        wget -qnc ${url} -O ${pair_opus}.txt.zip
        unzip -o -qq ${pair_opus}.txt.zip
        prefix=TED2020.${pair_opus}

        for split in valid test; do
            python3 -c "import sys; clean = lambda line: ' '.join(line.split()); pairs = dict(enumerate(zip(open('${prefix}.${src_opus}'), open('${prefix}.${tgt_opus}')))); sys.stdout.writelines(f'{clean(pairs[int(index)][0])}\t{clean(pairs[int(index)][1])}\n' for index in open('${split}.${pair}.ids'))" > ${split}.${pair}
            cut -f1 ${split}.${pair} > ${split}.${pair}.${src}
            cut -f2 ${split}.${pair} > ${split}.${pair}.${tgt}
            ln -fs ${split}.${pair}.${src} ${split}.${tgt}-${src}.${src}
            ln -fs ${split}.${pair}.${tgt} ${split}.${tgt}-${src}.${tgt}
            rm ${split}.${pair}
        done

        rm -f ${pair_opus}.txt.zip LICENSE README ${prefix}.{xml,${src_opus},${tgt_opus}}
    done
done

